#!/usr/bin/python3
import web, pypandoc, web.http, tempfile, os, mimetypes, datetime
from web import form
global urlroot
innerIP = '192.168.'
dbFile = "cmsdocs.db"
urlroot = "/cms"
pictureDir = "Pictures/"
urls = (
	urlroot, 'index',
	urlroot+'/', 'index',
	urlroot+'/edit','edit',
	urlroot+'/search','search',
	urlroot+'/list','list',
	urlroot+'/unlock','unlock',
	urlroot+'/upload','upload',
	urlroot+'/todocx','todocx',
	'/Pictures/(.*)','pictures'
)

def getFullDocumentList():
    global cmsdocs
    wdocs = db.select('docs', what="id")
    cmsdocs = []
    for i in wdocs:
        cmsdocs.append(i.id)

# Find documents with a common parent
def getSubordinateDocumentList(id):
    sdocs = db.select('docs', what='id,title',where="parent_doc=%d"%id, order="title ASC")
    subdocs = []
    for i in sdocs:
       subdocs.append((i.title,i.id))
    return subdocs

def getRecentDocumentList(id):
    sdocs = db.select('docs', what='id,title',order='last_edit DESC',limit=5)
    subdocs = []
    for i in sdocs:
        subdocs.append((i.title,i.id))
    return subdocs

app = web.application(urls, globals())
db = web.database(dbn='sqlite', db=dbFile)
getFullDocumentList()
render = web.template.render('templates/')

class docrec:
    def __init__(self,id,title,body,last_edit,refresh_rate,pid,protected,is_formatted,formatted,author):
        self.id = id
        self.pid = pid
        self.refresh_rate = refresh_rate
        self.title = title
        self.body = body
        self.last_edit = last_edit
        self.protected = protected
        self.formatted = formatted
        self.is_formatted = is_formatted
        self.urlroot = urlroot
        self.author = author
    def isProtected(self):
        return self.protected != 0
    def isFormatted(self):
        return self.is_formatted != 0
    def getFormatted(self):
        if self.is_formatted == 0:
            self.formatted = pypandoc.convert_text(self.body,"html",format="md")
            self.is_formatted = 1
        return self.formatted
    def getDocx(self):
        srcf = tempfile.mktemp()+".md"
        dstf = tempfile.mktemp()+".docx"
        f = open(srcf,"wb")
        f.write(('#'+self.title+"\n"+self.body).encode("utf-8"))
        f.close()
        pypandoc.convert_file(srcf,"docx",format="md",outputfile=dstf)
        os.unlink(srcf)
        return dstf
    def addDocList(self,cmsdocs):
        self.cmsdocs = cmsdocs
    def addSubDocList(self):
        self.sublist=getSubordinateDocumentList(self.id)
    def addSiblingDocList(self):
        self.siblinglist=getSubordinateDocumentList(self.pid)
    def addRecentDocList(self):
        self.recentlist=getRecentDocumentList(self.pid)
    def addEnvironment(self):
        self.environment = web.ctx.env

class index:
  def GET(self):
    i = web.input(docid=1)
    print("Client IP:",web.ctx.env['REMOTE_ADDR'])
    id = int(i.docid)
    docrow = db.select("docs", {'docid':id}, where='id=$docid')
    dl = docrow.list()
    if len(dl) == 0:
#        web.notfound()
        return "<html><title>404 - Not found</title><body><h2>Document not found</h2><a href='?docid=1'>Main document</a></body></html>"
    else:
        s = docrec(dl[0].id,dl[0].title,dl[0].body,dl[0].last_edit,dl[0].refresh_rate,
            dl[0].parent_doc,dl[0].protected,dl[0].is_formatted,dl[0].formatted,dl[0].author)
        web.http.modified(dl[0].last_edit)
        s.addSubDocList()
        s.addSiblingDocList()
        s.addRecentDocList()
        s.addEnvironment()
        # Format body with pandoc if necessary
        if not s.isFormatted():
            frm = s.getFormatted()
            db.update('docs',where='id=$id',formatted=frm,is_formatted=1,vars=locals())
        return render.index(s)

class edit:
    def GET(self):
        if not web.ctx.env['REMOTE_ADDR'].startswith(innerIP):
            return "Illegal operation"
        clientName = web.ctx.env["REMOTE_ADDR"]
#        if not web.ctx.env.has_key("REMOTE_USER"):
#            return "Illegal operation"
#	clientName = web.ctx.env["REMOTE_USER"]
#       clientName = "Anonymous"
        i = web.input(docid=1,pdocid=1)
        id = int(i.docid)
        pid = int(i.pdocid)
        docrow = db.select("docs", {'docid':id}, where='id=$docid')
        dl = docrow.list()
        if len(dl) == 0:
            s = docrec(0,'new document','-enter text here-',None,0,pid,0,0,'<h1>FEIL</h1>',clientName)
            return render.edit(s)
        else:
            s = docrec(dl[0].id,dl[0].title,dl[0].body,dl[0].last_edit,dl[0].refresh_rate,
                dl[0].parent_doc,dl[0].protected,dl[0].is_formatted,dl[0].formatted,clientName)
            if s.isProtected():
                return render.forbidden(s)
            # First, lock the document if not already locked for editing by someone else
            locktime = 5.0 # Minutes
            locked = db.query("UPDATE docs set locked_until=julianday()+$lt/1440 where id=$docid and locked_until<julianday()",{'lt':locktime,'docid':id})
            if locked==0:
                return "<html><h2>Document locked</h2>Try again in %d minutes<p><a href=%s?docid=%d>Back</html>" % (int(locktime),urlroot,id)

            return render.edit(s)

    def POST(self):
#        if not web.ctx.env.has_key("REMOTE_USER"):
#            return "Illegal operation"
#	clientName = web.ctx.env["REMOTE_USER"]
#       clientName = "Anonymous"
        if not web.ctx.env['REMOTE_ADDR'].startswith(innerIP):
            return "Illegal operation"
        clientName = web.ctx.env["REMOTE_ADDR"]
        i = web.input()	
        id = int(i.docid)
        pid = int(i.pid)
        refr = int(i.refresh)
        if id in cmsdocs:
            # Document already exists
            if i.body == '':
                print ("Deleting page ",i.title)
                db.delete('docs',where='id=$id',vars=locals())
                getFullDocumentList()
                raise web.seeother(urlroot)
            else:
#                print "Oppdaterer dokument"
                #q = ":".join("{:02x}".format(ord(c)) for c in i.doctext)
                #print q
                db.update('docs',where='id=$id',title=i.title,body=i.body,refresh_rate=refr,last_edit=web.db.SQLLiteral('CURRENT_TIMESTAMP'),parent_doc=pid,is_formatted=0,author=clientName,locked_until=0.0,vars=locals())
        else:
            if i.body != '':
                id = db.insert('docs',title=i.title,body=i.body,parent_doc=pid,author=clientName)
                getFullDocumentList()
        raise web.seeother(urlroot+"?docid=%d" % id);

class unlock:
    def GET(self):
#        if not web.ctx.env.has_key("REMOTE_USER"):
#            return "Illegal operation"
        if not web.ctx.env['REMOTE_ADDR'].startswith(innerIP):
            return "Illegal operation"
        clientName = web.ctx.env["REMOTE_ADDR"]
        i = web.input()
        id = int(i.docid)
        db.update('docs',where='id=$id',locked_until=0.0,vars=locals())
        if id==0: id=1 # In case we cancel a new document
        raise web.seeother(urlroot+"?docid=%d" % id);

class upload:
    def GET(self):
        if not web.ctx.env['REMOTE_ADDR'].startswith(innerIP):
            return "Illegal operation"
        picfiles = os.listdir(pictureDir)
        return render.upload(picfiles)
    def POST(self):
        if not web.ctx.env['REMOTE_ADDR'].startswith(innerIP):
            return "Illegal operation"
        fcontent=web.input(myfile={})
        filename = fcontent['myfile'].filename
        fout = open(pictureDir+filename,'wb')
        fout.write(fcontent['myfile'].file.read())
        fout.close()
        raise web.seeother(urlroot+"/upload")

class search:
    def GET(self):
        i = web.input(term='')
        st = i.term
        if st != '':
            doclist = db.query("SELECT id,title from docs where (body like $term or title like $term)",{'term':"%"+st+"%"})
            return render.search([st,doclist.list(),urlroot])
        else:
            raise web.seeother(urlroot);

class list:
    def GET(self):
      sdocs = db.select('docs', what='id,title', order="title ASC")
      subdocs = []
      for i in sdocs:
        subdocs.append((i.id,i.title))
      return render.list(subdocs,urlroot)

class pictures:
    def GET(self,file):
        print("Get picture:",file)
        fpath = pictureDir + file
        try:
            ctime = datetime.datetime.fromtimestamp(os.path.getmtime(fpath))
            web.http.modified(ctime)
            f = open(fpath, 'rb')
            mimetype,encoding = mimetypes.guess_type(fpath)
            web.header('Content-Type', mimetype)
            content = f.read()
            f.close()
            return content
        except web.webapi.NotModified:
            return web.notmodified()
        except Exception as e:
            print(type(e))
            return web.notfound()


class todocx:
  def GET(self):
    i = web.input(docid=1)
    id = int(i.docid)
    docrow = db.select("docs", {'docid':id}, where='id=$docid')
    dl = docrow.list()
    if len(dl) == 0:
        return "<html><title>404 - Not found</title><body><h2>Document not found</h2><a href='?docid=1'>Main document</a></body></html>"
    else:
        s = docrec(dl[0].id,dl[0].title,dl[0].body,dl[0].last_edit,dl[0].refresh_rate,
            dl[0].parent_doc,dl[0].protected,dl[0].is_formatted,dl[0].formatted,dl[0].author)
        web.http.modified(dl[0].last_edit)
        # Format body with pandoc to docx
        dstf = s.getDocx()
        web.header("Content-type","application/vnd.openxmlformats-officedocument.wordprocessingml.document")
        return open(dstf,'rb').read()

if __name__ == "__main__":
    app.run()



